#!/usr/bin/perl -w

# Skrypt wysyajcy SMS-y na wszystkie polskie sieci przez bramk
# Era - Dostp Skryptowy API Prywatne, wersja Podstawowa (darmowa).
# info: http://www.eraomnix.pl/service/gw/bAPIPrv.jsp
# Napisany w Perlu. 
# Wymaga: perl + LWP (RPM dla RedHat: perl-libwww)
#
# (c) 2003-2005 Jacek Fiok <jfiok@jfiok.org>; http://sms.jfiok.org
#
# wysya wiadomoci: dowolnie dugie w kawakach po 110 znakw; sieci: ERA GSM

use strict;
use HTTP::Request::Common;
use HTTP::Cookies;
use LWP::UserAgent;
use URI::URL;
use CGI;
# use LWP::Debug qw(+ -conns);
# LWP::Debug::trace('send()');

# ----------------------- pomocnicze -------------------------
my $debug = 0;				# czy "tryb gadatliwy"

sub debug { if ($debug) { print "[", shift, "]\n"; } }

sub zakoncz {
  my ($tekst, $ret) = @_;
  print "$tekst\n";
  exit $ret;
}

# format struktury danych:
# string ktry moemy znale w odpowiedzi z serwera =>
# [co naley z niego wywnioskowa-opis, kod powrotu ze skryptu ]
my %odpowiedzi = (
	"Skrzynka wiadomoci" => ["Wszystko OK", 0],
	"Zy numer" => ["Zy numer!", 2],
	"zosta wyczerpany" => ["Limit wiadomoci na dzi przekroczony!", 3]
);

# gwna procedurka analizujca odpowied serwera
# jeli nie umiemy nic wywnioskowa -> rzucamy [Nieznana Odpowiedz, 127]
sub analizujWynik {
	my $res = $_[0];
	my $searchString;
	my @val;
	while ( ($searchString, @val) = each (%odpowiedzi) ) {
	  if ($res =~ /$searchString/ ) {
		  print $odpowiedzi{$searchString}[0], "\n";
		  exit $odpowiedzi{$searchString}[1];
	  }		  
	}
	# jeli nie znaleziono w opisach
	print "Nieznana odpowied:\n$res\n";
	exit 127;
}

# getCookie ($nazwa) -> warto cookie; wymaga: $cookie_jar.
my $ckey = "";
my $cval = "";
my $cookie_jar = HTTP::Cookies->new;
# zwraca warto ciasteczka dla podanej nazwy klucza
sub cookieScanner {
	# my $i; for ($i=0; $i<5; $i++) { print $i, " : ", $_[$i], "\n"; }
	($ckey eq $_[1]) and $cval = $_[2]; 
}
sub getCookie {
	$cval = "";
	$ckey = shift;
	$cookie_jar->scan (\&cookieScanner);
	return $cval;
}

my $ua = new LWP::UserAgent;
$ua->timeout(30);
$ua->agent("Mozilla/5.0 Galeon/1.2.7 (X11; Linux i686; U;) Gecko/20021216");
$ua->env_proxy();
$ua->cookie_jar($cookie_jar);

# odwiedza stron $_[0]; w razie bdu wychodzi z tekstem $_[1] i kodem $_[2].
# w zmiennej globalnej $res lduje HTML -- wynik zapytania.
my $res; my $req;
sub visit {
        $res = $ua->request (GET $_[0]);
        if (!($res->is_success)) { zakoncz($_[1], $_[2]); }
}
# ----------------------- main() -----------------------------

select(STDERR); $| = 1;     # make unbuffered
select(STDOUT); $| = 1;     # make unbuffered

if ($#ARGV != 3 ) { die "Za ilo parametrw - podaj numer i tre sms-a"; }

my $numer = $ARGV[0];
my $tresc = $ARGV[1];
my $username = $ARGV[2];
my $password = $ARGV[3];

# wstpna obrbka numerw. nazw uytkownika na bramce ma by nr telefonu, lub e-mail.
# jeli numer, to ma si zaczyna na "48", bez plusa. wpp zostaw bez zmian.
$username =~ s/^\+//;
if (($username =~ /^[0-9]/) and (!($username =~ /^48/))) { $username = "48".$username; }
$numer =~ s/^\+48//;
$numer =~ s/^00//;

@{$ua->requests_redirectable} = ();

# --------- konwersacja -----------

my $poczatek=0;
my $dlugosc=110;

my $wiadomosc=$tresc;
my $ilosc_smsow = 1; 

if ((length($wiadomosc) % $dlugosc) != 0) { 
    $ilosc_smsow = ((length($wiadomosc) - (length($wiadomosc) % $dlugosc)) / $dlugosc) + 1; 
} else {
    $ilosc_smsow = length($wiadomosc) / $dlugosc;
}

debug("Liczba smsw do wysania: ".$ilosc_smsow."\n");

# ptla wysyajca po kawaku
for (my $i=1;$i<=$ilosc_smsow;$i++) {

	$tresc=substr($wiadomosc,$poczatek,$dlugosc);
	$poczatek += $dlugosc;

	debug ("wysyam...");
	my $url = url ('http://www.eraomnix.pl/msg/api/do/tinker/sponsored');
	$url->query_form( success => 'http://www.era.pl', failure => 'http://www.era.pl', login => $username, password => $password, number => '48'.$numer, message => $tresc);
	$res = $ua->get($url);	

	if (!($res->is_redirect)) { print $res->code."--\n".$res->message."--\n"; zakoncz("Co nie tak - res nie jest redirectem", 1); }

	# print $res->header('Location')."---\n";
	my $args = $res->header('Location');
	# trzeba obci base url, zostawi tylko argumenty get
	$args =~ s/.*\?//;
	my $cgi = new CGI($args);
	# print $cgi->param('X-ERA-error')."---\n";
	# print $cgi->param('X-ERA-counter')."---\n";
	
	if ( (!(defined($cgi->param('X-ERA-error')))) || ($cgi->param('X-ERA-error')==0) ) {	
	    if (defined($cgi->param('X-ERA-counter'))) {
		print ("Wszystko OK; pozostay limit wiadomoci: ".$cgi->param('X-ERA-counter')."\n"); 
	    } else {
		print ("Wszystko OK, ale serwer nie poda pozostaego limitu wiadomoci\n");
	    }
	
	} else {
	    my %errorcodes = (
		    1 => 'awaria systemu',
		    2 => 'nieautoryzowany uytkownik (sprawd haso?)',
		    3 => 'dostp zablokowany',
		    5 => 'bd skadni',
		    7 => 'wyczerpany limit SMS',
		    8 => 'bdny adres odbiorcy SMS',
		    9 => 'wiadomo zbyt duga',
		    10=> 'brak wymaganej liczby etonw' );
	    print "Bd wysyania : ".$errorcodes{$cgi->param('X-ERA-error')}, "\n";

	}


} # for (kawaki wiadomoci)


    

exit 0;
