#!/usr/bin/perl -w

# Skrypt wysyajcy SMS-y na wszystkie polskie sieci przez bramk
# www.idea.pl, portal "mbox" (tj. z koniecznoci logowania).
# https://www.idea.pl/portal/map/map
# Napisany w Perlu. 
# Wymaga: perl + LWP + SSL (RPM-y dla RedHat: perl-libwww, perl-crypt-SSLeay).
#
# (c) 2003 Jacek Fiok <jfiok@jfiok.org>; http://sms.jfiok.org
#
# wysya wiadomoci: do 640 znakw; wszystkie polskie sieci.
#
# Podzikowania dla:
# - Spley <spley@home.pl>
# - Maciej Krzyzanowski <spider@popnet.pl>

use strict;
use HTTP::Request::Common;
use HTTP::Cookies;
use LWP::UserAgent;
use Crypt::SSLeay;
# use LWP::Debug qw(+ -conns);
# LWP::Debug::trace('send()');

# ----------------------- pomocnicze -------------------------
my $debug = 0;				# czy "tryb gadatliwy"
my $mode = 0;				# czy pracujemy z raportami dorczenia
my $wait_secs = 0;			# opnienie oczekiwania na raport

sub debug { if ($debug) { print "[", shift, "]\n"; } }

sub zakoncz {
  my ($tekst, $ret) = @_;
  print "$tekst\n";
  exit $ret;
}

# format struktury danych:
# string ktry moemy znale w odpowiedzi z serwera =>
# [co naley z niego wywnioskowa-opis, kod powrotu ze skryptu ]
my %odpowiedzi = (
	"Skrzynka wiadomoci" => ["Wszystko OK", 0],
	"Zy numer" => ["Zy numer!", 2],
	"zosta wyczerpany" => ["Limit wiadomoci na dzi przekroczony!", 3]
);

# gwna procedurka analizujca odpowied serwera
# jeli nie umiemy nic wywnioskowa -> rzucamy [Nieznana Odpowiedz, 127]
sub analizujWynik {
	my $res = $_[0];
	my $searchString;
	my @val;
	while ( ($searchString, @val) = each (%odpowiedzi) ) {
	  if ($res =~ /$searchString/ ) {
		  print $odpowiedzi{$searchString}[0], "\n";
		  exit $odpowiedzi{$searchString}[1];
	  }		  
	}
	# jeli nie znaleziono w opisach
	print "Nieznana odpowied:\n$res\n";
	exit 127;
}

# getCookie ($nazwa) -> warto cookie; wymaga: $cookie_jar.
my $ckey = "";
my $cval = "";
my $cookie_jar = HTTP::Cookies->new;
# zwraca warto ciasteczka dla podanej nazwy klucza
sub cookieScanner {
	# my $i; for ($i=0; $i<5; $i++) { print $i, " : ", $_[$i], "\n"; }
	($ckey eq $_[1]) and $cval = $_[2]; 
}
sub getCookie {
	$cval = "";
	$ckey = shift;
	$cookie_jar->scan (\&cookieScanner);
	return $cval;
}

my $ua = new LWP::UserAgent;
$ua->timeout(30);
$ua->agent("Mozilla/5.0 Galeon/1.2.7 (X11; Linux i686; U;) Gecko/20021216");
$ua->env_proxy();
$ua->cookie_jar($cookie_jar);

# odwiedza stron $_[0]; w razie bdu wychodzi z tekstem $_[1] i kodem $_[2].
# w zmiennej globalnej $res lduje HTML -- wynik zapytania.
my $res; my $req;
sub visit {
        $res = $ua->request (GET $_[0]);
        if (!($res->is_success)) { zakoncz($_[1], $_[2]); }
}
# ----------------------- main() -----------------------------

select(STDERR); $| = 1;     # make unbuffered
select(STDOUT); $| = 1;     # make unbuffered

if ($#ARGV != 3 ) { die "Za ilo parametrw - podaj numer i tre sms-a"; }

my $numer = $ARGV[0];
my $tresc = $ARGV[1];
my $username = $ARGV[2];
my $password = $ARGV[3];
 
$numer =~ s/^\+48//;
$numer =~ s/^00//;

push @{ $ua->requests_redirectable }, 'POST';

# --------- konwersacja -----------

# 1. get sms-index
visit ("http://www.idea.pl/portal/map/map", 
       "Bd przy otwieraniu formularza [1]", 1);

# 2. send the POST login form
#my $par1 = 'https://www.idea.pl/portal/map/map/homeo;SID='.getCookie ("SID").'?_DARGS=/portal/layoutTemplates/html/header_files/login.jsp';
my $par1 = 'https://www.idea.pl/portal/map/map/one;SID='.getCookie ("SID").'?_DARGS=/portal/layoutTemplates/html/header_files/login.jsp';

debug ("Logging in: ".$par1);
#my $par1 = 'https://www.idea.pl/portal/map/map/homeo?_DARGS=/portal/layoutTemplates/html/header_files/login.jsp';
#debug ("Logging in: ".$par1);

$req = POST $par1, [
	'dyncharset' => 'UTF-8',
	'_D:password' => " ",
	'password' => $password,
	'_D:login' => " ",
	'login' => $username,
	'/amg/ptk/map/core/formhandlers/AdvancedProfileFormHandler.value.login' => $username,
	'_D:/amg/ptk/map/core/formhandlers/AdvancedProfileFormHandler.value.login'  => " ",
	'/amg/ptk/map/core/formhandlers/AdvancedProfileFormHandler.value.password' => $password,
	'_D:/amg/ptk/map/core/formhandlers/AdvancedProfileFormHandler.value.password' => " ",
	'/amg/ptk/map/core/formhandlers/AdvancedProfileFormHandler.login.x' => 0,
	'/amg/ptk/map/core/formhandlers/AdvancedProfileFormHandler.login.y' => 0,
#	'_D:/amg/ptk/map/core/formhandlers/AdvancedProfileFormHandler.login' => " ",
#	"/amg/ptk/map/core/formhandlers/AdvancedProfileFormHandler.extractDefaultValuesFromProfile" => "false",
#	"_D:/amg/ptk/map/core/formhandlers/AdvancedProfileFormHandler.extractDefaultValuesFromProfile" => " ",
#	"/amg/ptk/map/core/formhandlers/AdvancedProfileFormHandler.loginSuccessURL" => "http://www.idea.pl/portal/map/map/pim",
#	"_D:/amg/ptk/map/core/formhandlers/AdvancedProfileFormHandler.loginSuccessURL" => " ",
#	"/amg/ptk/map/core/formhandlers/AdvancedProfileFormHandler.loginErrorURL" => "http://www.idea.pl/portal/map/map",
	"_D:/amg/ptk/map/core/formhandlers/AdvancedProfileFormHandler.login" => " ",
	"/amg/ptk/map/core/formhandlers/AdvancedProfileFormHandler.extractDefaultValuesFromProfile" => "false",
	"_D:/amg/ptk/map/core/formhandlers/AdvancedProfileFormHandler.extractDefaultValuesFromProfile" => " ",
	"/amg/ptk/map/core/formhandlers/AdvancedProfileFormHandler.loginSuccessURL" => "http://www.idea.pl/portal/map/map/pim;SID=".getCookie("SID"),
	"_D:/amg/ptk/map/core/formhandlers/AdvancedProfileFormHandler.loginSuccessURL" => " ",
	"/amg/ptk/map/core/formhandlers/AdvancedProfileFormHandler.loginErrorURL" => "http://www.idea.pl/portal/map/map;SID=".getCookie("SID"),
	"_D:/amg/ptk/map/core/formhandlers/AdvancedProfileFormHandler.loginErrorURL" => " ",
	
#	"/amg/ptk/map/core/formhandlers/AdvancedProfileFormHandler.currentUrl" => "/portal/map/map/one?_requestid=".getCookie("VisitorId"),
#	"_D:/amg/ptk/map/core/formhandlers/AdvancedProfileFormHandler.currentUrl" => " ",
	"/amg/ptk/map/core/formhandlers/AdvancedProfileFormHandler.currentPageName" => "One/Home",
	"_D:/amg/ptk/map/core/formhandlers/AdvancedProfileFormHandler.currentPageName" => " ",
	
	"_DARGS" => "/portal/layoutTemplates/html/header_files/login.jsp"
];


$req->referer ("http://www.idea.pl/");
$res = $ua->request($req);
if (!($res->is_success)) { zakoncz("Bd przy logowaniu [2]", 1); }
#if (($res->content =~ /Nieprawidowe haso/) or (!($res->content =~ /Dzi jest/))) { zakoncz("Bd przy logowaniu - nieprawidowe haso? [2]", 1); } 
if (($res->content =~ /Nieprawidowe haso/) or (!($res->content =~ /Twoje SMSy:/))) { zakoncz("Bd przy logowaniu - nieprawidowe haso? [2]", 1); } 

debug ("zalogowany");

my $sms_zostalo = 666;
if ($res->content =~ /Twoje SMSy.*\n[^>]+>([^<]+)</) { $sms_zostalo = eval ($1); }
if ($sms_zostalo == 666) { zakoncz ("Nie mog odczyta iloci dostpnych SMSw", 1); }
if ($sms_zostalo == 0) { zakoncz ("Limit wiadomoci na ten miesic przekroczony", 3); }

visit ('http://www.idea.pl/portal/map/map/message_box?mbox_folder=INBOX&mbox_view=messageslist', "Bd przy otwarciu skrzynki SMS [3]", 1);
visit ('http://www.idea.pl/portal/map/map/message_box?mbox_view=newsms&mbox_edit=new', "Bd przy otwarciu formularza SMS [4]", 1);

debug ("przed wysaniem POST");

# _DARGS=/gear/mapmessagebox/smsform.jsp na WWW jest i w GET string i w POST :)
$req = POST 'http://www.idea.pl/portal/map/map/message_box?_DARGS=/gear/mapmessagebox/smsform.jsp', [
'_dyncharset' => "ISO8859_2",
'/amg/ptk/map/messagebox/formhandlers/MessageFormHandler.type' => "sms",
'_D:/amg/ptk/map/messagebox/formhandlers/MessageFormHandler.type' => " ",
'/amg/ptk/map/messagebox/formhandlers/MessageFormHandler.errorURL' => '/portal/map/map/message_box?mbox_view=newsms',
'_D:/amg/ptk/map/messagebox/formhandlers/MessageFormHandler.errorURL'  => " ",
'/amg/ptk/map/messagebox/formhandlers/MessageFormHandler.successURL' => '/portal/map/map/message_box?mbox_view=messageslist',
'_D:/amg/ptk/map/messagebox/formhandlers/MessageFormHandler.successURL' => " ",
'/amg/ptk/map/messagebox/formhandlers/MessageFormHandler.to' => $numer,
'_D:/amg/ptk/map/messagebox/formhandlers/MessageFormHandler.to' => " ",
'_D:/amg/ptk/map/messagebox/formhandlers/MessageFormHandler.body' => " ",
'/amg/ptk/map/messagebox/formhandlers/MessageFormHandler.body' => $tresc,
'counter' => (640 - length($tresc)),
'/amg/ptk/map/messagebox/formhandlers/MessageFormHandler.create.x' => 0,
'/amg/ptk/map/messagebox/formhandlers/MessageFormHandler.create.y' => 0,
'_D:/amg/ptk/map/messagebox/formhandlers/MessageFormHandler.create' => " ",
'_DARGS' => '/gear/mapmessagebox/smsform.jsp'
];
$req->referer('http://www.idea.pl/portal/map/map/message_box?mbox_view=newsms&mbox_edit=new');

debug ("dotarem OK do koca procedury, wysyam...");

$res = $ua->request($req);
if (!($res->is_success)) { zakoncz("Bd przy ostatecznym wysyaniu SMS [5]", 1);
}
# analizujWynik ($res->content);

my $sms_zostalo2 = 666;
if ($res->content =~ /Twoje SMSy.*\n[^>]+>([^<]+)</) { $sms_zostalo2 = eval ($1); }
if ($sms_zostalo2 == 666) { zakoncz ("Nie mog odczyta iloci dostpnych SMSw", 1); }
if ($sms_zostalo > $sms_zostalo2) {
	zakoncz ("Wszystko OK; pozostay limit wiadomoci: ".$sms_zostalo2, 0); 
} else {
	zakoncz ("Wiadomo wysana, ale STATUS NIEZNANY (pozostay limit: ".$sms_zostalo2.").", 0);
}

# TODO: to obsuguje raporty dorczenia!!!
# http://www.idea.pl/portal/map/map/message_box?mbox_view=sentmessageslist
